require 'rails_helper'
# require Hermes::Engine.root
#                       .join(*%w[spec factories lessors_factory])
#                       .to_s
# require Hermes::Engine.root
#                       .join(*%w[spec factories lessor_objectives_factory])
#                       .to_s
# require Hermes::Engine.root
#                       .join(*%w[spec factories housing_offers_factory])
#                       .to_s

RSpec.describe Hermes::LessorObjective, type: :model do
  it 'has a valid factory' do
    expect(FactoryBot.build(:lessor_objective)).to be_valid
  end

  # needed while old transition == true
  let!(:housing_family) { create(:family, slug: Hermes::ENV['offer_family_slug']) }

  let!(:base_lessor) { create(:lessor) }

  it 'should have created base_lessor' do
    expect(base_lessor).to be_present
  end

=begin
  let!(:lessor_objective_all) do
    create(
      :lessor_objective,
      department: '34',
      district: 'Montpellier',
      threshold_type: 'PLUS 60%',
      priority_public: true,
      never_inhabited: false,
      target_by_typologies: { all: 24 },
      realized_by_typologies: { all: 42 },
      lessor_id: base_lessor.id
    )
  end
=end

  # let!(:offer_test) do
  #   create(
  #     :tagset,
  #     superfields: {

  #     }
  #   )
  # end

  describe 'objectives are linked to lessor' do
    let!(:offers_batch1) do
      create_list(
        :housing_offer,
        3,
        department: '34',
        district: 'Montpellier',
        threshold_type: 'PLUS 60%',
        priority_public: true,
        never_inhabited: false,
        typology: 'T4',
        lessor_id: base_lessor.id
      )
    end

    let!(:objectives_batch2) do
      create_list(
        :lessor_objective,
        2,
        department: '95',
        district: 'Paris',
        threshold_type: 'PLUS',
        priority_public: false,
        never_inhabited: true,
        target_by_typologies: { T1: 12, T2: 28, T6: 3 },
        lessor_id: base_lessor.id
      )
    end

    let!(:offers_batch3) do
      create_list(
        :housing_offer,
        4,
        department: '95',
        district: 'Paris',
        threshold_type: 'PLUS',
        priority_public: false,
        never_inhabited: true,
        typology: 'T2',
        lessor_id: base_lessor.id
      )
    end

    it 'should return the right number of relations' do
      expect(Hermes::HousingOffer.where(lessor_id: base_lessor.id).count).to be 7
      expect(base_lessor.reload.housing_offers.count).to eq(7)
    end
  end

  describe 'zero hour scope bug' do
    let!(:lessor2) { create(:lessor) }
    let!(:lessor_objective1) do
      create(
        :lessor_objective,
        department: '34',
        district: 'Montpellier',
        threshold_type: 'PLUS 60%',
        priority_public: true,
        never_inhabited: false,
        target_by_typologies: { all: 24 },
        realized_by_typologies: { all: 42 },
        lessor_id: base_lessor.id,
        activation_date: DateTime.new(DateTime.current.year, 5, 5).utc
      )
    end

    let!(:lessor_objective2) do
      create(
        :lessor_objective,
        department: '44',
        district: 'Montpellier',
        threshold_type: 'PLUS 60%',
        priority_public: true,
        never_inhabited: false,
        target_by_typologies: { all: 24 },
        realized_by_typologies: { all: 42 },
        lessor_id: lessor2.id,
        activation_date: DateTime.new(DateTime.current.year, 1, 1).utc
      )
    end

    let!(:lessor_objective3) do
      create(
        :lessor_objective,
        department: '34',
        district: 'Montpellier',
        threshold_type: 'PLUS 60%',
        priority_public: true,
        never_inhabited: false,
        target_by_typologies: { all: 24 },
        realized_by_typologies: { all: 42 },
        lessor_id: lessor2.id,
        activation_date: DateTime.new(DateTime.current.year - 1, 2, 7).utc
      )
    end

    let!(:offer1) do
      create(
        :housing_offer,
        lessor: base_lessor,
        typology: 'T2',
        lessor_status: 'PLACE',
        threshold_type: 'PLUS 60%',
        department: '34',
        district: 'Montpellier',
        priority_public: true
      )
    end

    it 'show 2 lo in the scope result' do
      actives_lessors_objectives = Hermes::LessorObjective.actives
      expect(Hermes::LessorObjective.all.length).to eq(3)
      expect(actives_lessors_objectives.length).to eq(2)
      expect(lessor_objective1.reload.target_by_typologies).to(eq({ 'all' => 24 }))
      expect(lessor_objective1.reload.realized_by_typologies).to(eq({ 'all' => 1 }))
      expect(lessor_objective1.reload.objective_difference_by_typologies).to(eq({ 'all' => 23 }))
    end
  end
end
